define(['tslib', '@dd-abp/typings-wc16/DigDes.Web.Common.Functions/Logic/BaseLogic', '@docsvision/webclient/System/ServiceUtils', '@docsvision/webclient/System/UrlStore', '@docsvision/webclient/Helpers/MessageBox/MessageBox', '@docsvision/webclient/Generated/DocsVision.WebClient.Controllers', '@docsvision/webclient/System/ExtensionManager', '@docsvision/webclient/System/Service'], (function (tslib, BaseLogic, ServiceUtils, UrlStore, MessageBox, DocsVision_WebClient_Controllers, ExtensionManager, Service) { 'use strict';

    var CommonLogic = /** @class */ (function (_super) {
        tslib.__extends(CommonLogic, _super);
        function CommonLogic() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * Событие после открыти¤ карточки
         * @param layout
         */
        CommonLogic.prototype.CardOpened = function (layout) {
            return tslib.__awaiter(this, void 0, void 0, function () {
                return tslib.__generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, _super.prototype.cardOpened.call(this, layout)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        return CommonLogic;
    }(BaseLogic.BaseLogic));

    // Контроллер для работы c документами
    var DocumentsController = /** @class */ (function () {
        function DocumentsController(services) {
            this.services = services;
        }
        /**
         * Изменение состояния карточки
         * @param cardId идентификатор карточки
         */
        DocumentsController.prototype.ChangeState = function (cardId, stateName) {
            var url = UrlStore.urlStore.urlResolver.resolveUrl("ChangeState", "Documents");
            var data = {
                cardId: cardId,
                stateName: stateName
            };
            return this.services.requestManager.post(url, JSON.stringify(data), { isShowOverlay: true });
        };
        /**
         * Получить из дерева подразделений корневой элемент подразделения
         * @param unitId идентификатор подразделения
         */
        DocumentsController.prototype.GetRootUnit = function (unitId) {
            var url = UrlStore.urlStore.urlResolver.resolveUrl("GetRootUnit", "Documents");
            var data = {
                unitId: unitId
            };
            return this.services.requestManager.post(url, JSON.stringify(data));
        };
        /**
     * Получить из дерева подразделений корневой элемент подразделения
     * @param unitId идентификатор подразделения
     */
        DocumentsController.prototype.StartApprovalProcess = function (cardId) {
            var url = UrlStore.urlStore.urlResolver.resolveUrl("StartApprovalProcess", "Documents");
            var data = {
                cardId: cardId
            };
            return this.services.requestManager.post(url, JSON.stringify(data));
        };
        return DocumentsController;
    }());
    var $DocumentsController = ServiceUtils.serviceName(function (s) { return s.documentsController; });

    var DocumentLogic = /** @class */ (function (_super) {
        tslib.__extends(DocumentLogic, _super);
        function DocumentLogic() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //Метод переводящий состояние карточки в "Согласование"
        DocumentLogic.prototype.changeState = function (layout, stateName) {
            return tslib.__awaiter(this, void 0, void 0, function () {
                var cardStateService, stateIsChanged;
                return tslib.__generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            cardStateService = layout.getService($DocumentsController);
                            return [4 /*yield*/, cardStateService.ChangeState(layout.cardInfo.id, stateName)];
                        case 1:
                            stateIsChanged = _a.sent();
                            if (!stateIsChanged) return [3 /*break*/, 3];
                            return [4 /*yield*/, this.refreshLayout(layout)];
                        case 2:
                            _a.sent();
                            _a.label = 3;
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * Отправить карточку на согласование
         * @param layout
         */
        DocumentLogic.prototype.sendToApproval = function (layout) {
            return tslib.__awaiter(this, void 0, void 0, function () {
                var documentLogic, approvalProcessIsStarted;
                return tslib.__generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            documentLogic = layout.getService($DocumentsController);
                            return [4 /*yield*/, documentLogic.StartApprovalProcess(layout.cardInfo.id)];
                        case 1:
                            approvalProcessIsStarted = _a.sent();
                            if (!approvalProcessIsStarted) {
                                MessageBox.MessageBox.ShowWarning("Нет доступного маршрута");
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return DocumentLogic;
    }(CommonLogic));

    /**
     * Класс общей логики для эксплуатационной документации
     */
    var ContractM2Logic = /** @class */ (function (_super) {
        tslib.__extends(ContractM2Logic, _super);
        function ContractM2Logic() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * Открытие карточки
         * @param layout
         */
        ContractM2Logic.prototype.CardOpened = function (layout) {
            return tslib.__awaiter(this, void 0, void 0, function () {
                return tslib.__generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, _super.prototype.CardOpened.call(this, layout)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        ContractM2Logic.prototype.setExecutorInfo = function (layout) {
            return tslib.__awaiter(this, void 0, void 0, function () {
                var executorControl, organizationControl, subdivisionControl, departmentSrvc, documentSrvc, department, organization;
                return tslib.__generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            executorControl = layout.controls.tryGet("executor");
                            if (!executorControl) {
                                return [2 /*return*/];
                            }
                            organizationControl = layout.controls.tryGet("organization");
                            subdivisionControl = layout.controls.tryGet("subdivision");
                            if (!organizationControl || !subdivisionControl) {
                                return [2 /*return*/];
                            }
                            if (!!executorControl.value) return [3 /*break*/, 1];
                            organizationControl.value = null;
                            subdivisionControl.value = null;
                            return [3 /*break*/, 4];
                        case 1:
                            departmentSrvc = layout.getService(DocsVision_WebClient_Controllers.$DepartmentController);
                            documentSrvc = layout.getService($DocumentsController);
                            return [4 /*yield*/, departmentSrvc.getStaffDepartment(executorControl.value.unitId)];
                        case 2:
                            department = _a.sent();
                            subdivisionControl.value = department;
                            return [4 /*yield*/, documentSrvc.GetRootUnit(department.id)];
                        case 3:
                            organization = _a.sent();
                            organizationControl.value = organization;
                            _a.label = 4;
                        case 4: return [2 /*return*/];
                    }
                });
            });
        };
        return ContractM2Logic;
    }(DocumentLogic));

    /**
     * Событие после открытия карточки
     * @param sender
     */
    function ddContractM2Scripts_CardOpened(sender) {
        return tslib.__awaiter(this, void 0, void 0, function () {
            var logic;
            return tslib.__generator(this, function (_a) {
                logic = new ContractM2Logic();
                logic.CardOpened(sender);
                return [2 /*return*/];
            });
        });
    }
    function ddContractM2Scripts_sendToApprovalButtonClick(sender, e) {
        return tslib.__awaiter(this, void 0, void 0, function () {
            var logic;
            return tslib.__generator(this, function (_a) {
                logic = new ContractM2Logic();
                logic.sendToApproval(sender.layout);
                return [2 /*return*/];
            });
        });
    }
    function ddContractM2Scripts_partnerINNChanged(sender, e) {
        return tslib.__awaiter(this, void 0, void 0, function () {
            var regexp, test;
            return tslib.__generator(this, function (_a) {
                if (e.newValue != null) {
                    regexp = new RegExp('^[0-9]{0,10}$');
                    test = regexp.test(e.newValue);
                    if (!test) {
                        sender.value = e.oldValue;
                    }
                }
                return [2 /*return*/];
            });
        });
    }
    function ddContractM2Scripts_executorChanged(sender, e) {
        return tslib.__awaiter(this, void 0, void 0, function () {
            var logic;
            return tslib.__generator(this, function (_a) {
                logic = new ContractM2Logic();
                logic.setExecutorInfo(sender.layout);
                return [2 /*return*/];
            });
        });
    }

    var ContractM2EventHandlers = /*#__PURE__*/Object.freeze({
        __proto__: null,
        ddContractM2Scripts_CardOpened: ddContractM2Scripts_CardOpened,
        ddContractM2Scripts_sendToApprovalButtonClick: ddContractM2Scripts_sendToApprovalButtonClick,
        ddContractM2Scripts_partnerINNChanged: ddContractM2Scripts_partnerINNChanged,
        ddContractM2Scripts_executorChanged: ddContractM2Scripts_executorChanged
    });

    // Контроллер для работы c документами
    var CompanyController = /** @class */ (function () {
        function CompanyController(services) {
            this.services = services;
        }
        /**
         * Проверить имеет ли подразделение родительское подразделение
         * @param unitId идентификатор подразделения
         */
        CompanyController.prototype.CompanyHaveParent = function (companyId) {
            var url = UrlStore.urlStore.urlResolver.resolveUrl("CompanyHaveParent", "Company");
            var data = {
                companyId: companyId
            };
            return this.services.requestManager.post(url, JSON.stringify(data));
        };
        return CompanyController;
    }());
    var $CompanyController = ServiceUtils.serviceName(function (s) { return s.companyController; });

    // Главная входная точка всего расширения
    // Данный файл должен импортировать прямо или косвенно все остальные файлы, 
    // чтобы rollup смог собрать их все в один бандл.
    // Регистрация расширения позволяет корректно установить все
    // обработчики событий, сервисы и прочие сущности web-приложения.
    ExtensionManager.extensionManager.registerExtension({
        name: "DigDes.Traineeship.Web.Front",
        version: "5.5.15",
        globalEventHandlers: [
            ContractM2EventHandlers
        ],
        layoutServices: [
            Service.Service.fromFactory($DocumentsController, function (services) { return new DocumentsController(services); }),
            Service.Service.fromFactory($CompanyController, function (services) { return new CompanyController(services); })
        ]
    });

}));
//# sourceMappingURL=extension.js.map
