﻿import { Department } from "@docsvision/webclient/BackOffice/Department";
import { $LayoutCardController } from "@docsvision/webclient/Generated/DocsVision.WebClient.Controllers";
import { GenModels } from "@docsvision/webclient/Generated/DocsVision.WebClient.Models";
import { CustomButton } from "@docsvision/webclient/Platform/CustomButton";
import { TextBox } from "@docsvision/webclient/Platform/TextBox";
import { IDataChangedEventArgs } from "@docsvision/webclient/System/IDataChangedEventArgs";
import { IEventArgs } from "@docsvision/webclient/System/IEventArgs";
import { Layout } from "@docsvision/webclient/System/Layout";
import { ContractM2Logic } from "../../Logic/Documents/ContractM2Logic"

/**
 * Событие после открытия карточки
 * @param sender
 */
export async function ddContractM2Scripts_CardOpened(sender: Layout) {
    const logic = new ContractM2Logic();
    logic.CardOpened(sender);
}

export async function ddContractM2Scripts_sendToApprovalButtonClick(sender: CustomButton, e: IEventArgs): Promise<any> {
    const logic = new ContractM2Logic();
    logic.sendToApproval(sender.layout);
}

export async function ddContractM2Scripts_partnerINNChanged(sender: TextBox, e: IDataChangedEventArgs): Promise<any> {

    if (e.newValue!=null) {

        let regexp = new RegExp('^[0-9]{0,10}$');
        let test = regexp.test(e.newValue);

        if (!test) {
            sender.value = e.oldValue;
        }
    }
}

export async function ddContractM2Scripts_executorChanged(sender: CustomButton, e: IEventArgs): Promise<any> {
    const logic = new ContractM2Logic();
    logic.setExecutorInfo(sender.layout);
}



