﻿import * as ContractM2EventHandlers from "./EventHandlers/Documents/ContractM2EventHandlers";
import { extensionManager } from "@docsvision/webclient/System/ExtensionManager";
import { Service } from "@docsvision/webclient/System/Service";
import { $DocumentsController, DocumentsController } from "./Services/DocumentsController";
import { $RequestManager } from "@docsvision/webclient/System/$RequestManager";
import { $CompanyController, CompanyController } from "./Services/CompanyController ";


// Главная входная точка всего расширения
// Данный файл должен импортировать прямо или косвенно все остальные файлы, 
// чтобы rollup смог собрать их все в один бандл.

// Регистрация расширения позволяет корректно установить все
// обработчики событий, сервисы и прочие сущности web-приложения.
extensionManager.registerExtension({
    name: "DigDes.Traineeship.Web.Front",
    version: "5.5.15",
    globalEventHandlers: [
        ContractM2EventHandlers
    ],
    layoutServices: [
        Service.fromFactory($DocumentsController, (services: $RequestManager) => new DocumentsController(services)),
        Service.fromFactory($CompanyController, (services: $RequestManager) => new CompanyController(services))
    ]
})