﻿import { Layout } from "@docsvision/webclient/System/Layout";
import { CommonLogic } from "../CommonLogic"
import { $DocumentsController } from "../../Services/DocumentsController"
import { MessageBox } from "@docsvision/webclient/Helpers/MessageBox/MessageBox";

export class DocumentLogic extends CommonLogic {

    //Метод переводящий состояние карточки в "Согласование"
    public async changeState(layout: Layout, stateName: string) {

        let cardStateService = layout.getService($DocumentsController);

        let stateIsChanged = await cardStateService.ChangeState(layout.cardInfo.id, stateName);//OnApproval
        if (stateIsChanged) {
            await this.refreshLayout(layout);
        }
    }

    /**
     * Отправить карточку на согласование
     * @param layout
     */
    public async sendToApproval(layout: Layout) {
        //this.changeState(layout, States.Document.ContractM2.Approval.Name);

        let documentLogic = layout.getService($DocumentsController);
        let approvalProcessIsStarted = await documentLogic.StartApprovalProcess(layout.cardInfo.id);

        if (!approvalProcessIsStarted) {
            MessageBox.ShowWarning("Нет доступного маршрута");
        }
    }
}