﻿import { GenModels } from "@docsvision/webclient/Generated/DocsVision.WebClient.Models";
import { $RequestManager } from "@docsvision/webclient/System/$RequestManager";
import { serviceName } from "@docsvision/webclient/System/ServiceUtils";
import { urlStore } from "@docsvision/webclient/System/UrlStore";

// Контроллер для работы c документами
export class CompanyController {

    constructor(private services: $RequestManager) { }

    /**
     * Проверить имеет ли подразделение родительское подразделение
     * @param unitId идентификатор подразделения
     */
    public CompanyHaveParent(companyId: string): Promise<boolean> {
        var url = urlStore.urlResolver.resolveUrl("CompanyHaveParent", "Company");
        var data = {
            companyId
        };
        return this.services.requestManager.post(url, JSON.stringify(data));
    }
}

export type $CompanyController = { companyController: CompanyController };
export const $CompanyController = serviceName((s: $CompanyController) => s.companyController);