import { serviceName } from "@docsvision/webclient/System/ServiceUtils";
import { urlStore } from "@docsvision/webclient/System/UrlStore";
// Контроллер для работы c документами
var DocumentsController = /** @class */ (function () {
    function DocumentsController(services) {
        this.services = services;
    }
    /**
     * Изменение состояния карточки
     * @param cardId идентификатор карточки
     */
    DocumentsController.prototype.ChangeState = function (cardId, stateName) {
        var url = urlStore.urlResolver.resolveUrl("ChangeState", "Documents");
        var data = {
            cardId: cardId,
            stateName: stateName
        };
        return this.services.requestManager.post(url, JSON.stringify(data), { isShowOverlay: true });
    };
    /**
     * Получить из дерева подразделений корневой элемент подразделения
     * @param unitId идентификатор подразделения
     */
    DocumentsController.prototype.GetRootUnit = function (unitId) {
        var url = urlStore.urlResolver.resolveUrl("GetRootUnit", "Documents");
        var data = {
            unitId: unitId
        };
        return this.services.requestManager.post(url, JSON.stringify(data));
    };
    /**
 * Получить из дерева подразделений корневой элемент подразделения
 * @param unitId идентификатор подразделения
 */
    DocumentsController.prototype.StartApprovalProcess = function (cardId) {
        var url = urlStore.urlResolver.resolveUrl("StartApprovalProcess", "Documents");
        var data = {
            cardId: cardId
        };
        return this.services.requestManager.post(url, JSON.stringify(data));
    };
    return DocumentsController;
}());
export { DocumentsController };
export var $DocumentsController = serviceName(function (s) { return s.documentsController; });
//# sourceMappingURL=DocumentsController.js.map