﻿import { GenModels } from "@docsvision/webclient/Generated/DocsVision.WebClient.Models";
import { $RequestManager } from "@docsvision/webclient/System/$RequestManager";
import { serviceName } from "@docsvision/webclient/System/ServiceUtils";
import { urlStore } from "@docsvision/webclient/System/UrlStore";

// Контроллер для работы c документами
export class DocumentsController {

    constructor(private services: $RequestManager) { }

    /**
     * Изменение состояния карточки
     * @param cardId идентификатор карточки
     */
    public ChangeState(cardId: string,stateName:string): Promise<boolean> {
        var url = urlStore.urlResolver.resolveUrl("ChangeState", "Documents");
        var data = {
            cardId,
            stateName
        };
        return this.services.requestManager.post(url, JSON.stringify(data), { isShowOverlay: true });
    }

    /**
     * Получить из дерева подразделений корневой элемент подразделения
     * @param unitId идентификатор подразделения
     */
    public GetRootUnit(unitId: string): Promise<GenModels.DepartmentModel> {
        var url = urlStore.urlResolver.resolveUrl("GetRootUnit", "Documents");
        var data = {
            unitId
        };
        return this.services.requestManager.post(url, JSON.stringify(data));
    }

    /**
 * Получить из дерева подразделений корневой элемент подразделения
 * @param unitId идентификатор подразделения
 */
    public StartApprovalProcess(cardId: string): Promise<boolean> {
        var url = urlStore.urlResolver.resolveUrl("StartApprovalProcess", "Documents");
        var data = {
            cardId
        };
        return this.services.requestManager.post(url, JSON.stringify(data));
    }
}

export type $DocumentsController = { documentsController: DocumentsController };
export const $DocumentsController = serviceName((s: $DocumentsController) => s.documentsController);